# d2txt_x.rb  version 1.1 2008.11.22
# Copyright (C) T. Yoshiizumi, 2008 All rights reserved.
  # xdoc2txtŕϊeLXgt@C̉sR[h𒲐.
  # s \r\n łȂ \n ̏ꍇ '|' ɕϊ (Excel̕sZPs)
  # s̓rɂ \r  \r\n ɕϊ (power-pointɑ)
  # *.ppt̃wb_(u}X^ ^Cg̏ݒvȂǂ폜)
  # Excel̃V[g擪ɉy[WR[ht
  # ̋ϓt̂߂̋󔒂

$KCODE = 'SJIS'

# *.ppt̃wb_폜
def ppt_convert(w)
  w = w.gsub(/}X^ +(^Cg|eLXg)̏ݒ\r/, "\r")
  while w =~ /\r( *\d+ *x|\*)\r/
    w.sub!(/\r( *\d+ *x|\*)\r/, "\r")
  end
  return w
end

## main
$WORKDIR = "C:\\usr\\d2txt"
$option = '-n -r=0'
wargv = []
ARGV.each {|i|
  if i =~ /^-opt=(.+)$/i
    $option = $1
  elsif i =~ /^-path=(.+)$/i
    $WORKDIR = $1
    $WORKDIR = $WORKDIR.sub(/\\$/, "")
  else
    wargv.push(i)
  end
}
argv_count = wargv.size
$option.gsub!(/-f/, "")

unless test(?d, $WORKDIR)
  $WORKDIR = Dir.pwd.gsub(/\//, "\\")
end
xdoc_txt = sprintf("%s\\xdoc2txt.exe", $WORKDIR)
unless test(?e, xdoc_txt)
  exit
end

for org_fname in wargv
  next  unless test(?f, org_fname)
  next  if org_fname =~ /\.txt$/i

  cmd = sprintf("|\"%s\" %s \"%s\"", xdoc_txt, $option, org_fname)
  infile = open(cmd, "rb")  rescue next
  body = ''
  while org_l = infile.gets
    l = ppt_convert(org_l)
    while l =~ /\r[^\n]/
      l.gsub!(/\r([^\n])/, "\r\n\\1")
    end
    while l =~ /[^\r]\n/
      l.gsub!(/([^\r])\n/, "\\1|")
    end
    l.sub!(/\A\n/, "|")
      #  ̋ϓt̂߂̋󔒂
    l.gsub!(/^([ @]*)(([^ \t@][ @]+)+[^ \t@])([ @]*)$/) {|mp|
      s1=$1; s2=$2; s4=$4
      mp = s1 + s2.gsub(/[ @]+/, "") + s4
    }
    l.gsub!(/([^ \t@][ @]+){2,}[^ \t@]/) {|mp|  mp=mp.gsub(/[ @]+/, "")}
    body = body + l
  end
  infile.close
  next  if body == ''
  lines = body.split(/\r\n/)
  while lines[0] == ''  # `̋󔒍s폜
    lines.shift
  end
  if org_fname =~ /\.xls$/i  # Excel̃V[g̓'##'t
    count = 0
    for i in 0..(lines.size-1)
      if lines[i] =~ /^\[([^\t]+)\]$/
        sheet_title = $1
        count += 1
        header = sprintf("##%d %s", count, sheet_title)
        if count > 1 and lines[i-1] != ''
          header = "\n" + header
        end
        lines[i] = header
      end
    end
  end
  out_fname = org_fname + ".txt"
  outfile = open(out_fname, "w")  rescue next
  outfile.puts lines
  outfile.close
end
