# install_dx.rb  2008.11.22  d2txt_x̃CXg[
# Copyright (C) T. Yoshiizumi, 2008 All rights reserved.
require 'URI'
require 'win32ole'
require 'Win32API'
require 'fileutils'

# http̃t@C𓾂BMS-windowspŁB
  # require 'win32ole' Kv
def get_http_ms(url)
  unless defined? $MSHTTP
    $MSHTTP = WIN32OLE.new('Msxml2.XMLHTTP')
  end
  sec_limit = 20  # timeout20bƂ
  $MSHTTP.Open "GET", url, false
  sec_count = 0
  while $MSHTTP.readyState != 1
    sleep 1
    sec_count += 1
    break  if sec_count > sec_limit
  end
  if sec_count > sec_limit
    $MSHTTP.abort
    return ''
  end
  $MSHTTP.Send
  sec_count = 0
  while $MSHTTP.readyState != 4
    sleep 1
    sec_count += 1
    break  if sec_count > sec_limit
  end
  if sec_count > sec_limit
    $MSHTTP.abort
    return ''
  end
  if $MSHTTP.status == 200
    body = $MSHTTP.responseBody.pack("c*")
  else
    body = ''
  end
  $MSHTTP.abort
  return body
end

# lzhɂ̉
def melt_lzh(fname)
  unless defined? $ctrl_lha
    unlha_dll = "UNLHA32.DLL"
    $ctrl_lha = Win32API.new(unlha_dll, 'Unlha', %w(L P P I), 'I')
    $running_lha = Win32API.new(unlha_dll, 'UnlhaGetRunning', '', 'I')
  end
  while $running_lha.call() != 0
    wdummy = ''
  end
  cmd = sprintf("x \"%s\"", fname)
  res = "\x00" * 4096
  if $ctrl_lha.call(-1, cmd, res, 4096) == 0
    return true
  else
    return false
  end
end

# zipɂ̉
def melt_zip(fname)
  unless defined? $ctrl_zip
    unzip_dll = "UNZIP32.DLL"
    $ctrl_zip = Win32API.new(unzip_dll, 'UnZip', %w(L P P I), 'I')
    $running_zip = Win32API.new(unzip_dll, 'UnZipGetRunning', '', 'I')
  end
  while $running_zip.call() != 0
    wdummy = ''
  end
  cmd = sprintf("--i -qq -x \"%s\"", fname)
  res = "\x00" * 4096
  if $ctrl_zip.call(-1, cmd, res, 4096) == 0
    return true
  else
    return false
  end
end

# ^ꂽtH_쐬
  # ɃtH_ΉȂAȂΐVɍ
  # w薼tH_łȂt@CȂǂȂ dir2, dir3, cc̖OŐVK쐬
def check_and_make_dir(dir_name)
  count = 1
  while true
    if test(?d, dir_name)
      break
    end
    unless test(?e, dir_name)
      Dir.mkdir(dir_name)
      break
    end
    count += 1
    dir_name = sprintf("%s%d", dir_name, count)
  end
  return dir_name
end

# t@C̍ċNIRs[
def file_repeat_copy(src_list, dest_dir)
  dest_dir = dest_dir.gsub(/\\/, "/")
  unless test(?d, dest_dir)
    return
  end
  for fname in src_list
    fname = fname.gsub(/\\/, "/")
    next  unless test(?e, fname)
    if test(?d, fname)
      base_name = File.basename(fname)
      new_dest_dir = dest_dir.sub(/\/$/, "")  + "/" + base_name
      Dir.mkdir(new_dest_dir)  unless test(?e, new_dest_dir)
      next  unless test(?d, new_dest_dir)
      wcard = fname.sub(/\/$/, "") + "/*"
      new_src_list = Dir.glob(wcard)
      file_repeat_copy(new_src_list, new_dest_dir)
    else  # fnamefBNgł͂Ȃ
      FileUtils.copy(fname, dest_dir, {:preserve => true})
    end
  end
end

# W̃GfB^o
def get_text_editor
  r = 'NotePad.exe'
  infile = open("|ASSOC .txt")  rescue  (return r)
  l = infile.gets
  infile.close
  l.chomp!
  if l =~ /^\.txt=(.+)$/i
    type_str = $1
  else
    return r
  end
  pattern1 = Regexp.compile(sprintf("^%s=\"(.+?)\"", type_str))
  pattern2 = Regexp.compile(sprintf("^%s=([^ ]+)", type_str))

  infile = open("|FTYPE #{type_str}")  rescue  (return r)
  l = infile.gets
  infile.close
  l.chomp!
  if l =~ pattern1
    r = $1
  elsif l =~ pattern2
    r = $1
  end
  return r
end

# eLXgoɃGfB^œǂނ߂̃ob`o
def bat_contents(fname)
  str = <<EOS
@echo off
IF %1=="" GOTO END
SET MYEDITOR=$$$
IF /I "%~x1"==".txt" GOTO READ_TEXT
C:\\usr\\d2txt\\d2txt_x.exe "-path=C:\\usr\\d2txt" "-opt=-n -r=0" %1
IF EXIST "%~1.txt" GOTO READ_CONVERT
GOTO END
:READ_TEXT
"%MYEDITOR%" %1
GOTO END
:READ_CONVERT
"%MYEDITOR%" "%~1.txt"
REM DEL /F /Q "%~1.txt"
:END
EOS
  r = get_text_editor
  str.sub!(/\$\$\$/, r)
  outfile = open(fname, "w")
  outfile.print str
  outfile.close
end

# NbNŃeLXgo邽߂VBSo
def vbs_contents(fname, bat_name)
  str = <<EOS2
Const OPEN_PROGRAM = "!!!"
Set w = CreateObject("Shell.Application").Windows
For i = w.count-1 To 0 Step - 1
If InStr(w.item(i).FullName, "Program Files") = 0 Then Exit For
Next
If i = -1 Then WScript.Quit()
Set oFItem = w.item(i).Document.FocusedItem
If oFItem Is Nothing Then WScript.Quit()
Set WShell = CreateObject("WScript.Shell")
WShell.Run("""" & OPEN_PROGRAM & """ """ & oFItem.Path & """")
EOS2
  str.sub!(/!!!/, bat_name)
  outfile = open(fname, "w")
  outfile.print str
  outfile.close
end

## main
# CXg[tH_߂
w = "C:\\usr"
w = check_and_make_dir(w)
folder = check_and_make_dir(w + "\\d2txt")
old_files = Dir.glob(folder.gsub(/\\/, "/") + "/*")  # t@C̎擾

message_box = Win32API.new('user32', 'MessageBoxA', 'LPPI', 'I')
w = "Kvȃt@C̃_E[hƂ̉𓀂s܂H"
r = message_box.call(0, w, 'eLXgo\tg@CXg[', 4)
if r == 6
  # _E[hׂt@Curl𓾂
  body = get_http_ms('http://www31.ocn.ne.jp/~h_ishida/xdoc2txt.html')
  if body == ''
  w = "_E[hł܂łDx̃CXg[\tgsĂ݂邩C܂́CC:\\usr\\d2txt̉Ƀ_E[h𓀂ĉD"
  message_box.call(0, w, 'eLXgo\tg@CXg[f', 0)
    exit
  end
  ulist = []
  body.gsub(/<a +href="(.+?)">.+?<\/a>/i) {|mp|
    ulist << $1
    mp = ''
  }
  zip_url = ''; lzh_url = ''
  for wurl in ulist
    if zip_url == '' and /d2txt.+\.zip$/i =~ wurl
      zip_url = wurl
    elsif lzh_url == '' and /crypt.+\.lzh$/i =~ wurl
      lzh_url = wurl
    end
  end
  if zip_url == '' or lzh_url == ''
  w = "_E[hł܂łDx̃CXg[\tgsĂ݂邩C܂́CC:\\usr\\d2txt̉Ƀ_E[h𓀂ĉD"
  message_box.call(0, w, 'eLXgo\tg@CXg[f', 0)
    exit
  end

  # Kvȃt@C_E[h
  flist = []  # t@C̖OL^
  zip_body = get_http_ms(zip_url)
  lzh_body = get_http_ms(lzh_url)
  if zip_body != '' and lzh_body != ''
    FileUtils.rm_r(old_files, {:force => true})  # tH_̉ɂ
  end
  urls = [zip_url, lzh_url]
  [zip_body, lzh_body].each {|body|
    url = urls.shift
    unless body == ''
      w = URI.split(url)
      fname = folder + "\\" + File.basename(w[5])
      outfile = open(fname, "wb")
      outfile.print body
      outfile.close
      flist << fname
    end
  }

  # _E[ht@C
  Dir.chdir(folder)
  for fname in flist
    next  unless test(?e, fname)
    ext = ''
    if fname =~ /\.lzh$/i
      r = melt_lzh(fname)
      File.unlink(fname)  if r == true
    elsif fname =~ /\.zip$/i
      r = melt_zip(fname)
      File.unlink(fname)  if r == true
    end
  end
end

wsh = WIN32OLE.new("WScript.Shell")
unless wsh
  w = "WSHĂȂ߃CXg[ł܂D}jAQƂȂƂŃCXg[ĉD"
  message_box.call(0, w, 'eLXgo\tg@CXg[', 0)
  exit
end

# KvȃtH_̎擾
src_dir = File.dirname(ExerbRuntime::filepath())
src_dir.gsub!(/\//, "\\")
if src_dir =~ /\\$/
  src_dir = src_dir.sub(/\\$/, "")
end

prog_name = 'd2txt_x.exe'
src_file = sprintf("%s\\%s", src_dir, prog_name)
unless test(?e, src_file)
  w = sprintf("AvP[Vt@C %s݂܂DCXg[߂܂D", src_file)
  message_box.call(0, w, 'eLXgo\tg@CXg[', 0)
  exit
end

dest_dir = folder
sendto_dir = wsh.SpecialFolders("SendTo")
if sendto_dir =~ /\\$/
  sendto_dir = sendto_dir.sub(/\\$/, "")
end
desktop_dir = wsh.SpecialFolders("Desktop")
if desktop_dir =~ /\\$/
  desktop_dir = desktop_dir.sub(/\\$/, "")
end

# t@C̃Rs[
src_list = [src_dir + "\\d2txt_x.exe", src_dir + "\\d2txt_x.txt",
            src_dir + "\\table_convert.exe", src_dir + "\\table_convert.txt",
            src_dir + "\\xdoc2txt̃CXg[yюg.txt",
            src_dir + "\\sample_table.txt",
            src_dir + "\\!͂߂ɂǂ݉.txt",
            src_dir + "\\script"]
unless src_dir.downcase == dest_dir.downcase
  file_repeat_copy(src_list, dest_dir)
end

# ob`R}h̍쐬
bf1 = sprintf("%s\\d2txt_y.bat", dest_dir)
outfile = open(bf1, "w")
outfile.printf("@echo off\n\"%s\\d2txt_x.exe\" \"-path=%s\" \"-opt=-n -r=0\" %%*\n", dest_dir, dest_dir)
outfile.close
    ##
bf2 = sprintf("%s\\table_convert_g.bat", dest_dir)
outfile = open(bf2, "w")
outfile.printf("@echo off\n\"%s\\table_convert.exe\" -g %%*\n", dest_dir, dest_dir)
outfile.close
    ##
bf3 = sprintf("%s\\table_convert_k.bat", dest_dir)
outfile = open(bf3, "w")
outfile.printf("@echo off\n\"%s\\table_convert.exe\" -k %%*\n", dest_dir, dest_dir)
outfile.close
bf4 = sprintf("%s\\d2txt_z.bat", dest_dir)
bat_contents(bf4)
bf5 = sprintf("%s\\OneCrickeLXgo.vbs", dest_dir)
vbs_contents(bf5, bf4)

# V[gJbg̍쐬
exe_file = bf1
link_file1 = sprintf("%s\\T eLXg𒊏o.lnk", sendto_dir)
shortcut = wsh.CreateShortCut(link_file1)
shortcut.targetPath = exe_file
shortcut.save
    ##
exe_file = bf2
link_file2 = sprintf("%s\\G \̂Ă悱t].lnk", sendto_dir)
shortcut = wsh.CreateShortCut(link_file2)
shortcut.targetPath = exe_file
shortcut.save
    ##
exe_file = bf3
link_file3 = sprintf("%s\\K \̉ӏւ̕ϊ.lnk", sendto_dir)
shortcut = wsh.CreateShortCut(link_file3)
shortcut.targetPath = exe_file
shortcut.save
    ##
exe_file = bf5
link_file4 = sprintf("%s\\OneCrickeLXgo.lnk", desktop_dir)
shortcut = wsh.CreateShortCut(link_file4)
shortcut.targetPath = exe_file
shortcut.save

# uninstall̂߂̃ob`o
tmp_def = dest_dir + "\\uninstall_DX.def"
outfile = open(tmp_def, "w")
outfile.printf("@ECHO OFF\n")
outfile.printf("DEL /F /Q \"%s\"\n", link_file1)
outfile.printf("DEL /F /Q \"%s\"\n", link_file2)
outfile.printf("DEL /F /Q \"%s\"\n", link_file3)
outfile.printf("DEL /F /Q \"%s\"\n", link_file4)
outfile.printf("CD /D \"%s\"\n", dest_dir)
outfile.printf("CD ..\n")
outfile.printf("RMDIR /S /Q \"%s\"\n", dest_dir)
outfile.close
    ##
tmp_bat = dest_dir + "\\uninstall_DX.bat"
outfile = open(tmp_bat, "w")
outfile.printf("@ECHO OFF\n")
outfile.printf("CD /D \"%s\"\n", dest_dir)
outfile.printf("CD ..\n")
outfile.printf("TYPE \"%s\" > uninstall_x.bat\n", tmp_def)
outfile.printf("uninstall_x.bat\n")
outfile.close

# I
w = sprintf("Kvȃt@C%sɃRs[Cuvj[ɎO̍ڂo^܂D\r\nuT eLXg𒊏ov@uG \̂Ă悱t]v@uK \̉ӏւ̕ϊvłD\r\n܂CfXNgbvɁuOneCrickeLXgov݂܂DV[gJbgL[蓖ĂƁC^b`őł܂D", dest_dir)
message_box.call(0, w, 'eLXgo\tg@CXg[I', 0)
exit
